const merge = require('webpack-merge');
const MiniCssExtractPlugin = require('mini-css-extract-plugin');
const HtmlWebpackPlugin = require('html-webpack-plugin');
const { getProjectPath } = require('../common/utils');
const webpackCommon = require('../common/webpack.common');

module.exports = (isProd, appConfig, extendEnv) => {
  const result = {
    plugins: [
      new HtmlWebpackPlugin({
        inject: true,
        template: getProjectPath(appConfig.htmlPluginTemplate)
      })
    ]
  };

  if (isProd) {
    result.plugins.push(
      new MiniCssExtractPlugin({
        filename: `css/[name].css?v=${extendEnv.version}`,
        allChunks: true,
        ignoreOrder: true
      })
    );
  }

  return merge(webpackCommon(appConfig, extendEnv, { isProd, isServer: false }), result);
};
