const merge = require('webpack-merge');
const LoadablePlugin = require('@loadable/webpack-plugin');
const baseConfig = require('./webpack.base');
const { getProjectPath } = require('../common/utils');

module.exports = function(appConfig, extendEnv) {
  return merge(
    baseConfig(appConfig, extendEnv, {
      isServer: false,
      isHotServer: true,
      isSetCommonAlias: true,
      isProd: false
    }),
    {
      // 入口文件
      entry: getProjectPath(appConfig.hotSsrClientEntry),
      node: {
        fs: 'empty'
      },
      // 输出信息
      output: {
        // 输出文件路径
        path: getProjectPath(appConfig.hotSsrClientOutput.path),
        publicPath: appConfig.hotSsrClientOutput.publicPath || '/',
        filename: 'js/[name].js',
        chunkFilename: 'js/[name].js'
      },
      plugins: [new LoadablePlugin()]
    }
  );
};
